/*
 * clock.h - Clock framework for NEC EMMAXXX SoCs
 *
 * Copyright (C) 2009  NEC Electronics Corporation
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef __ASM_EMMA_CLOCK_H
#define __ASM_EMMA_CLOCK_H

#include <asm/emma/clkdev.h>

struct clkops {
	void			(*enable)(struct clk *);
	void			(*disable)(struct clk *);
	unsigned long		(*getrate)(struct clk *);
};

struct clk {
	const struct clkops	*ops;
	unsigned long		rate;
	unsigned int		enabled;
};

#define INIT_CLKREG(_clk, _devname, _conname)		\
	{						\
		.clk		= _clk,			\
		.dev_id		= _devname,		\
		.con_id		= _conname,		\
	}

#define DEFINE_CLK(_name, _ops, _rate)			\
struct clk clk_##_name = {				\
		.ops	= _ops,				\
		.rate	= _rate,			\
	}

extern void clks_register(struct clk_lookup *clks, size_t num);

#endif /* __ASM_EMMA_CLOCK_H */
