/*
 * include/linux/nec_candy_pd.h
 *
 * Platform data for the NEC Candy Ethernet device.
 *
 * Author: Wade Farnsworth <wfarnsworth@mvista.com>
 *
 * 2006 (c) MontaVista Software, Inc. This file is licensed under
 * the terms of the GNU General Public License version 2. This program
 * is licensed "as is" without any warranty of any kind, whether express
 * or implied.
 */

#ifndef NEC_CANDY_PD_H
#define NEC_CANDY_PD_H

enum candy_clks_enum {
	MIIC_CLKS25,	/* Reserved */
	MIIC_CLKS33,	/* Divided by 14 */
	MIIC_CLKS50,	/* Divided by 20 */
	MIIC_CLKS66,	/* Divided by 28 */
	MIIC_CLKS100,	/* Divided by 40 */
	MIIC_CLKS133,	/* Divided by 56 */
	MIIC_CLKS166,	/* Divided by 70 */
	MIIC_CLKS200	/* Reserved */
};

struct nec_candy_platform_data {
	unsigned char mac_addr[6];
	unsigned long pmd_addr;
	int rmii;	/* 0:MII, 1:RMII */
	int clks;
};

#endif
